/* goprocs.c
 *
 * Adapted for xigc v3.3  1/94    =SC
 */

/**
*	Program:     Go
*	Developer:  James R. Logan Jr. 
*  	email address:  loganj@cs.byu.edu
*  	(801) 378-6551
*
* The contents of this file are in the public domain, and may be 
* used for any purpose.  Acknowledgement to the author would be 
* appreciated, but is not required.
**/

#include <stdio.h>
#include "goprocs.h"
#include "filter.h"

#define EMPTY 0
#undef WHITE
#define WHITE 1
#undef BLACK
#define BLACK 2

#ifndef TRUE
#define TRUE 1
#endif

#ifndef FALSE
#define FALSE 0
#endif

#define rollcallemptyspot -1
#define rollcallendoflist -2

extern game maingame;
extern char rules;

char coltable[20] =   /* note A-T with I missing */
  {'A','B','C','D','E','F','G','H',    'J','K',
   'L','M','N','O','P','Q','R','S','T', 0};

short 
  rollcallstart,		/* Start linked list of armies to be relinked */
  otherside[Playtypes] = 
    {Black,White,Black,White,Black,White,Black,White,Black,White},
  rollcall[Maxstones];



initialize (g,size) game *g; unsigned char size; {
/* This procedure initializes the game structure supplied by the caller */
short center,i,j,k,r1,c1,value,w1,w2,w3,w4,w5,w6,w7,w8;
SGFstruct *sgf = &g->sgf;

  g->width = size;

/* Initialize game parameters */
  rollcallstart = rollcallendoflist;	/* No one is on the roll */
  g->stoneNumber = 0; 		/* Number of stones & passes played */
  g->playNumber = 0;
  g->moveStatus.koSpot = -1;
  g->moveStatus.passCount = 0;  /* number of consecutive passes in the game */
  g->moveStatus.captures  = 0;   /* the diRection of captured stones */
  g->moveStatus.deadWhite = 0;   g->moveStatus.deadBlack = 0;
  w1 = g->width; w2 = w1 + w1; w3 = w2 + w1; w4 = w3 + w1;
  w5 = w4 + w1; w6 = w5 + w1; w7 = w6 + w1; w8 = w7 + w1;
  g->maxStone = w1 * w1; 

/* Initialize tables indicating each positions distance from edge of board */
  center = ((g->width + 1) / 2); j = 0; k = 0;
  for (i = 0; i < g->maxStone; i++) {
    value = 1 + (i % g->width);
    if (value > center) value = g->width - value + 1;
    j = j + g->width;
    if (j >= g->maxStone) { k++; j = k; }
  }

/* Initialize the neighbor board and pattern sequence index */
  for (i = 0; i < g->maxStone; i++) {
    g->neibrd[i] = 0xFFFFFFFFL; 
  }

  j = 0;
  for (i = 0; i < g->width; i++) {
    g->neibrd[j] = g->neibrd[j] & 0xEEEEEEEEL; 
    g->neibrd[j+w1-1] = g->neibrd[j+w1-1] & 0xDDDDDDDDL;
    g->neibrd[i] = g->neibrd[i] & 0xBBBBBBBBL; 
    g->neibrd[g->maxStone-w1+i] = g->neibrd[g->maxStone-w1+i] & 0x77777777L;
    if (w1 > 1) {
      g->neibrd[j+1] = g->neibrd[j+1] & 0xEEEEEEEFL; 
      g->neibrd[j+w1-2] = g->neibrd[j+w1-2] & 0xDDDDDDDFL;
      g->neibrd[i+w1] = g->neibrd[i+w1] & 0xBBBBBBBFL; 
      g->neibrd[g->maxStone-w2+i] = g->neibrd[g->maxStone-w2+i] & 0x7777777FL;
    }
    if (w1 > 2) {
      g->neibrd[j+2] = g->neibrd[j+2] & 0xEEEEEEFFL; 
      g->neibrd[j+w1-3] = g->neibrd[j+w1-3] & 0xDDDDDDFFL;
      g->neibrd[i+w2] = g->neibrd[i+w2] & 0xBBBBBBFFL; 
      g->neibrd[g->maxStone-w3+i] = g->neibrd[g->maxStone-w3+i] & 0x777777FFL;
    }
    if (w1 > 3) {
      g->neibrd[j+3] = g->neibrd[j+3] & 0xEEEEEFFFL; 
      g->neibrd[j+w1-4] = g->neibrd[j+w1-4] & 0xDDDDDFFFL;
      g->neibrd[i+w3] = g->neibrd[i+w3] & 0xBBBBBFFFL; 
      g->neibrd[g->maxStone-w4+i] = g->neibrd[g->maxStone-w4+i] & 0x77777FFFL;
    }
    if (w1 > 4) {
      g->neibrd[j+4] = g->neibrd[j+4] & 0xEEEEFFFFL; 
      g->neibrd[j+w1-5] = g->neibrd[j+w1-5] & 0xDDDDFFFFL;
      g->neibrd[i+w4] = g->neibrd[i+w4] & 0xBBBBFFFFL; 
      g->neibrd[g->maxStone-w5+i] = g->neibrd[g->maxStone-w5+i] & 0x7777FFFFL;
    }
    if (w1 > 5) {
      g->neibrd[j+5] = g->neibrd[j+5] & 0xEEEFFFFFL; 
      g->neibrd[j+w1-6] = g->neibrd[j+w1-6] & 0xDDDFFFFFL;
      g->neibrd[i+w5] = g->neibrd[i+w5] & 0xBBBFFFFFL; 
      g->neibrd[g->maxStone-w6+i] = g->neibrd[g->maxStone-w6+i] & 0x777FFFFFL;
    }
    if (w1 > 6) {
      g->neibrd[j+6] = g->neibrd[j+6] & 0xEEFFFFFFL; 
      g->neibrd[j+w1-7] = g->neibrd[j+w1-7] & 0xDDFFFFFFL;
      g->neibrd[i+w6] = g->neibrd[i+w6] & 0xBBFFFFFFL; 
      g->neibrd[g->maxStone-w7+i] = g->neibrd[g->maxStone-w7+i] & 0x77FFFFFFL;
    }
    if (w1 > 7) {
      g->neibrd[j+7] = g->neibrd[j+7] & 0xEFFFFFFFL; 
      g->neibrd[j+w1-8] = g->neibrd[j+w1-8] & 0xDFFFFFFFL;
      g->neibrd[i+w7] = g->neibrd[i+w7] & 0xBFFFFFFFL; 
      g->neibrd[g->maxStone-w8+i] = g->neibrd[g->maxStone-w8+i] & 0x7FFFFFFFL;
    }
    j = j + g->width;
  }

/* Initialize the row and column arrays */
  i = 0;
  r1 = 0;
  while (i < g->maxStone) {
    for (c1 = 0; c1 < g->width; c1++) 
      { g->rowbrd[i] = r1; g->colbrd[i] = c1; i = i + 1; }
    r1 = r1 + 1;
  }

  for (i = 0; i < g->maxStone; i++) {
    simpleneis(g,&g->nabor[i],i);
    g->board[i] = Blank; 
    g->brdtohst[i] = 0;
  }

  for (i = 0; i < Maxhistory; i++) {
    sgf->stonenums[i] = 0; 
    sgf->gametype[i] = -1;
    g->history[i] = 0;
    sgf->typehistory[i] = Playstone;
  }

  sgf->typehistory[0] = Playstone + Black;
  g->stathistory[0] = g->moveStatus;
  allarmies(g);  /* Create the armies */
}



drawstone(g,stone,who,drawit,numberit) 
game *g; int stone; int who; int drawit; int numberit; {

  if (drawit) {
    if (who == White)
      drawStone(g->rowbrd[stone]+1, g->colbrd[stone]+1, WHITE, TRUE );
    else if (who == Black)
      drawStone(g->rowbrd[stone]+1, g->colbrd[stone]+1, BLACK, TRUE );
} }



drawall(g) game *g; {
short i,s;
  if (g->stoneNumber > 0) {
    for (i = 0; i < Maxstones; i++) {
      if (g->board[i] == Black) 
        drawstone(g,i,Black,DRAWIT,TRUE);
      else if (g->board[i] == White) 
        drawstone(g,i,White,DRAWIT,TRUE);
    } 

    for (i = g->stoneNumber; i > 0; i--)	/* Find last stone played */
      if (g->history[i] >= 0) break;		/* that is not "pass" */
    if (i > 0) {
      s = g->history[i];
      drawstone(g,s,g->board[s],DRAWIT,TRUE);	/* Draw it */
    }
  }
}



undrawstone(g,stone,drawit) game *g; int stone; int drawit; {
  if (drawit)
    drawStone(g->rowbrd[stone]+1, g->colbrd[stone]+1, EMPTY, TRUE );
}


rolladd(g,army) game *g; short army; {
short s;
  s = g->army[army].first;
  if (rollcall[s] == rollcallemptyspot) {
    while (s >= 0) {
      rollcall[s] = rollcallstart;
      rollcallstart = s;
      s = g->armyflnk[s];   /* Link to next army man */
} } }



createarmy(g,newstone) game *g; short newstone; {
short color,newarmy;
armystruct *army;

  newarmy = g->avail;			/* get next available army number */

  g->avail = g->army[g->avail].fp;
  g->army[g->avail].bp = newarmy;

  g->armymen[newstone] = newarmy;	/* Set new army number */
  g->armyflnk[newstone] = -1;	/* This is the last  stone in the army */
  g->armyblnk[newstone] = -1;	/* This is the first stone in the army */

  army = &g->army[newarmy];

  army->color = color = g->board[newstone];

  army->first = newstone; 
  army->last = newstone;
  army->size = 0;		/* Cause size to be done by buildarmies */
}


deletearmy(g,old) game *g; short old; {
short army,avail,n1,n2;
armystruct *oldarmy,*availarmy;

/* Make old army number available */
  if (old > 0) { 
    oldarmy = &g->army[old];

/* Remove the army. */
    if (oldarmy->fp != g->avail) {
      availarmy = &g->army[g->avail];
      if (oldarmy->bp > 0) 
      	g->army[oldarmy->bp].fp = oldarmy->fp; 
      g->army[oldarmy->fp].bp = oldarmy->bp;
      g->army[availarmy->bp].fp = old;
      oldarmy->fp = g->avail; 
      oldarmy->bp = availarmy->bp;
      availarmy->bp = old;
    }
    oldarmy->first = -1; 
    oldarmy->last  = -1; 
    oldarmy->size  = 0;
    g->avail = old; 
} } 


linkarmies(g) game *g; {
/* Create a 1 man army for each square.  Then look at neighboring squares, 
   and if any are the same color army then merge the new army into the 
   neighboring army */
neighbors *nabor;
short a1,n,s,s1;

/* First, delete all the armies to be rebuilt. */
  s = rollcallstart;       /* First man link list */
  while (s >= 0) {         /* Visit each old army man */
    a1 = g->armymen[s];     /* Save old army number */
    if (g->army[a1].first >= 0) 
      deletearmy(g,a1);
    g->armymen[s] = -1;
    s = rollcall[s];
  }

/* Rebuild armies from the linked list of rollcall positions. */
  s = rollcallstart;		/* First man link list */
  while (s >= 0) {		/* Visit each old army man */
    createarmy(g,s);		/* Create a new army for each army man */
    nabor = &g->nabor[s];	/* Get the neighbors */
    for (n = 0; n < nabor->neis; n++) {	/* Visit each neighbor */
      s1 = nabor->stone[n];
      a1 = g->armymen[s1];
      if ((a1 > 0) && (g->army[a1].first >= 0))
        armymerge(g,s1,s); 
    }
    s1 = rollcall[s];
    rollcall[s] = rollcallemptyspot;
    s = s1;
  }
  rollcallstart = rollcallendoflist;	/* No one is on the roll */
  buildarmies(g);
}



tallyarmy(g,armynumber) game *g; short armynumber; {
/* Add up the number of computer and opponent stones that border on 
   each army.  Since blank armies do not contain eyes the eye parameter 
   for blank armies is used to count eyes for non blank armies. */
char stncolor;

short enemy,friend,lib,size;
unsigned char stonemark[Maxstones];
neighbors *nabor;
short a1,n,s,s1;
armystruct *army;

  army = &g->army[armynumber];
  if ((army->size <= 0) && (army->first >= 0)) {

    for (n = 0; n < Maxstones; n++)
      stonemark[n] = 0;

    enemy = 0; friend = 0; 
    lib = 0; size = 0;

    s = army->first;	/* first man in army */
    stncolor = g->board[s];
    while (s >= 0) {
      size++;
      nabor = &g->nabor[s];	/* get the neighbors */
      for (n = 0; n < nabor->neis; n++) {  /* go through neighbors */
	s1 = nabor->stone[n];
	a1 = g->armymen[s1];

        if (!stonemark[s1]) {
          stonemark[s1] = 1;    /* Don't process this position again. */

/* Process non blank armies here */
	  if (stncolor != Blank) {
	    if (g->board[s1] == Blank) {
	      lib++;
	    } else if (g->board[s1] != stncolor) {
	      enemy++;
	    }

/* Process blank armies here. */
	  } else {
	    if (g->board[s1] == White) {
	      friend++;
	    } else if (g->board[s1] == Black) {	/* Needed to avoid Blank */
	      enemy++;
      } } } }
      s = g->armyflnk[s]; /* link to next man */
    }

    army->enemy = enemy;
    army->friend = friend;
    army->lib = lib;
    army->size = size;
} }



/* Build blank armies first, then non blank armies, so that eyes are 
**   counted properly 
*/
buildarmies(g) game *g; {
short army;

/* Go through each army */
  army = g->army[g->avail].bp;
  while (army > 0) {
    tallyarmy(g,army);
    army = g->army[army].bp;
} }



/* Determine whether the two stones should be merged into the same army.  
**   Non blank armies of the same color are merged, blank armies  
**   are merged. 
*/

armymerge(g,s1,s2) game *g; short s1; short s2; {
short a1,a2,s;
armystruct *army1,*army2;

  a1 = g->armymen[s1]; 
  a2 = g->armymen[s2];

  army1 = &g->army[a1];
  army2 = &g->army[a2];

/* Here we must compare army colors instead of stone colors on the board,
   because a stone may have changed color and misrepresent the army. */
  if ((a1 > 0) && (a1 != a2) && (army2->first >= 0) &&
      (army1->color == army2->color)) {
    
/* Change a2 number to a1 for all the a2 armymen */
    s = army2->first;  /* first man in army */
    while (s >= 0) 
     { g->armymen[s] = a1; s = g->armyflnk[s]; }
      	
/* Link army a2 into army a1 */
    g->armyflnk[army1->last] = army2->first;
    g->armyblnk[army2->first] = army1->last;
    army1->last = army2->last;
    army1->size = 0;   /* required for buildarmies */
    deletearmy(g,a2);
} }



allarmies(g) game *g; {
/* Clear all army numbers in the army array, and call build armies */
short n,s;
armystruct *army;

  g->avail = 2;      /* next available army number */
  g->army[1].bp = 0; g->army[2].bp = 1;

  for (n = 0; n < Maxarmies; n++) { 
    army = &g->army[n];
    army->first = -1; 
    army->fp = n + 1;	/* initialize armies forward links */
  }

  for (s = 0; s < g->maxStone; s++) {
    g->armymen[s] = 1; g->armyflnk[s] = s - 1;
    rollcall[s] = rollcallemptyspot;
  }

  army = &g->army[1];
  army->first = g->maxStone - 1;
  army->color = Blank;	/* required for buildarmies */
  army->size = 0;		/* required for buildarmies */
  buildarmies(g);
#if 0
  rolladd(g,1);	/* Required for linkarmies */
  linkarmies(g);
#endif
}



/* Establish the number and position of neighbors to a stone.  Gather 
**   the stone numbers of neighboring positions into the nabor.stone
**   array.  
*/

simpleneis(g,nabor,stone) game *g; neighbors *nabor; short stone; {
short i = 0;
long	validNeibrd = g->neibrd[stone];

  if ( validNeibrd & 1) { 
    nabor->stone[i] = stone - 1;  /* TBD make a nabor->stone Ptr	*/
    nabor->direction[i++] = 1; 	  /* TBD make a nabor->direction Ptr	*/
  }
  if ( validNeibrd & 2) { 
    nabor->stone[i] = stone + 1; 
    nabor->direction[i++] = 2;
  }
  if ( validNeibrd & 4) { 
    nabor->stone[i] = stone - g->width;
    nabor->direction[i++] = 4;
  }
  if ( validNeibrd & 8) { 
    nabor->stone[i] = stone + g->width;
    nabor->direction[i++] = 8;
  }
  nabor->neis = i;
}

unsigned char anystone( g, newstone )
	game *g;
	int newstone;
{
	if( g->board[newstone] != Blank ) {
		return( g->board[newstone] + 1 );
	}
	else {
		return( FALSE );
	}
}


/* Clear the blank army for rebuilding, update any neighboring enemy 
   armies diRectly, and do nothing for neighboring friendly armies. 
   Friendly armies are merged and updated by linkarmies at the end. 
*/
int addastone(g,newstone,drawit,numberit,playtype,crules) 
        game *g; 
	int newstone; 
	int drawit; 
	int numberit; 
	int playtype;
	int crules; {

short a1,n;
short a3,playedstone,s;
neighbors *nabor;
mstatus oldstatus;
unsigned char armymark[Maxarmies];
SGFstruct *sgf = &g->sgf;

  playedstone = -1;
  if ((newstone >= 0) && 
      (newstone < g->maxStone) &&
      ((crules & GO_DO_ILLEGAL) || 
       ((newstone != g->moveStatus.koSpot) || 
         (g->who != g->moveStatus.koColor)) && 
        (g->board[newstone] == Blank))) {

    if (g->board[newstone] != Blank) 
      liftastone(g,newstone,STEPGAME);

    g->stoneNumber++; /* Increment history counter */
    sgf->hsttolst[g->stoneNumber] = g->brdtohst[newstone];
    g->brdtohst[newstone] = g->stoneNumber;
    if (playtype < Pass) g->playNumber++;

/* Record the playNumber, even for handicap stones - for showall proc */
    sgf->stonenums[g->stoneNumber] = g->playNumber;
    sgf->gametype[g->stoneNumber] = sgf->gametype[g->stoneNumber-1];
    sgf->typehistory[g->stoneNumber] = playtype + g->who;
    oldstatus = g->moveStatus;  /* Save the old status */
    g->board[newstone] = g->who;
    drawstone(g,newstone,g->who,drawit,numberit); 
    g->moveStatus.koSpot = -1;  /* Clear the ko position */
    g->moveStatus.captures = 0; /* Clear captures */
    a1 = g->armymen[newstone]; /* Old blank army number */
    
    for (n = 0; n < Maxarmies; n++)
      armymark[n] = 0;

    nabor = &g->nabor[newstone];
    for (n = 0; n < nabor->neis; n++) {
      s = nabor->stone[n];
      a3 = g->armymen[s]; 
      rolladd(g,a3);
      if (g->board[s] != Blank) { 
        if (!armymark[a3]) {
          armymark[a3] = 1;    /* Don't consider this army again. */
	  if (g->army[a3].color == otherside[g->who]) {
	    g->army[a3].enemy++;
	    g->army[a3].lib--;
	    if ((crules & GO_DO_CAPTURES) && (g->army[a3].lib <= 0)) { 
	      capture(g,g->army[a3].first,drawit,numberit);
	      g->moveStatus.captures = 
		  g->moveStatus.captures | nabor->direction[n];
      } } } }
      g->army[a3].size = 0; /* Rebuild all neighboring  armies */
    }
    rolladd(g,a1);
    linkarmies(g);
    
/* If the added stone was illegal for lack of liberties then remove it */
    a3 = g->armymen[newstone]; 
    if (g->army[a3].lib <= 0) {
      if (crules & GO_DO_SUICIDE) {

	if (g->army[a3].size == 1) 
	  g->moveStatus.captures = 
	    g->moveStatus.captures | SUICIDE1;
	else
	  g->moveStatus.captures = 
	    g->moveStatus.captures | SUICIDE2;

	  if (g->who == Black)
		fprintf( stderr, "\rLOCAL: Suicide move by black at %c%d.\n",
	    coltable[g->rowbrd[newstone]], g->colbrd[newstone]+1);
	  else
		fprintf( stderr, "\rLOCAL: Suicide move by white at %c%d.\n",
	    coltable[g->rowbrd[newstone]], g->colbrd[newstone]+1);

	capture(g,g->army[g->armymen[newstone]].first,drawit,numberit);

/* Record the move and update data structures */
        g->board[newstone] = Blank;
        g->moveStatus.passCount = 0;
        playedstone = newstone;
        g->history[g->stoneNumber] = newstone;
        g->stathistory[g->stoneNumber] = g->moveStatus;

      } else {
        if (g->who == Black) 
	  fprintf( stderr, "\rLOCAL: Bad add by white at %c%d, no liberties.\n",
	    coltable[g->rowbrd[newstone]], g->colbrd[newstone]+1);
        else 
	  fprintf( stderr, "\rLOCAL: Bad add by black at %c%d, no liberties.\n",
	    coltable[g->rowbrd[newstone]], g->colbrd[newstone]+1);

        removeastone(g,newstone,g->moveStatus,drawit,numberit,crules);
        g->moveStatus = oldstatus;
        g->stoneNumber--;
        if (playtype < Pass) g->playNumber--;
      }
    } else {
/* If the added stone merged into another army then there is no ko spot */
      a1 = g->armymen[newstone];	/* Old blank army number */
      if (g->army[a1].size > 1) g->moveStatus.koSpot = -1;
/* Record the move and update data structures */
      g->moveStatus.passCount = 0;
      playedstone = newstone;
      g->history[g->stoneNumber] = newstone;
      g->stathistory[g->stoneNumber] = g->moveStatus;
/* Redraw the stone if there were captures to set the most recent move mark */
      if (g->moveStatus.captures) 
        drawstone(g,newstone,g->who,drawit,numberit); 
    } 
  } else {
    if (g->who == Black) 
	fprintf( stderr, "\rLOCAL: Bad add by white at %c%d.\n",
	  coltable[g->rowbrd[newstone]], g->colbrd[newstone]+1);
    else 
	fprintf( stderr, "\rLOCAL: Bad add by black at %c%d.\n",
	  coltable[g->rowbrd[newstone]], g->colbrd[newstone]+1);
    if (newstone == g->moveStatus.koSpot) 
        fprintf( stderr, "\rLOCAL: Can't move to ko spot.\n");
    if (g->board[newstone] != Blank)  
        fprintf(stderr, "\rLOCAL: Position already occupied.\n");
  }
  return playedstone;
}



linkastone(g,stone)
	game *g;
	int stone; {

short a1,a3,n,s;
neighbors *nabor;

  a1 = g->armymen[stone];
  nabor = &g->nabor[stone];
  for (n = 0; n < nabor->neis; n++) {
    s = nabor->stone[n];
    a3 = g->armymen[s]; 
    rolladd(g,a3);
    g->army[a3].size = 0; /* Rebuild all neighboring  armies */
  }
  rolladd(g,a1);
  linkarmies(g);
} 



liftastone(g,oldstone,gametype) 
        game *g; 
	int oldstone; 
	int gametype; {

short a1,n;
short a3,s;
neighbors *nabor;
SGFstruct *sgf = &g->sgf;

  if ((oldstone >= 0) && 
      (oldstone < g->maxStone) &&
      (g->board[oldstone] != Blank)) {

    g->stoneNumber++; /* Increment history counter */
    g->history[g->stoneNumber] = oldstone;
    sgf->hsttolst[g->stoneNumber] = g->brdtohst[oldstone];
    g->brdtohst[oldstone] = g->stoneNumber;

/* Record the playNumber, even for handicap stones - for showall proc */
    sgf->stonenums[g->stoneNumber] = g->playNumber;
    sgf->gametype[g->stoneNumber] = gametype;
    sgf->typehistory[g->stoneNumber] = Blankstone + g->who;
    g->board[oldstone] = Blank;
    undrawstone(g,oldstone,DRAWIT);
    g->moveStatus.koSpot = -1;  /* Clear the ko position */
    g->moveStatus.captures = 0; /* Clear captures */

    linkastone(g,oldstone);
} }    



removeastone(g,oldstone,status,drawit,numberit,crules)
	game *g; 
	int oldstone; 
	mstatus status; 
	int drawit; 
	int numberit;
	int crules; {
/* Clear the blank army for rebuilding, update any neighboring enemy 
   armies diRectly, and do nothing for neighboring friendly armies. 
   Friendly armies are merged and updated by linkarmies at the end. */
short a1,n,s;
short color,wh; 
neighbors *nabor;
SGFstruct *sgf = &g->sgf;

  if ((oldstone >= 0) && (oldstone < g->maxStone) &&
      (g->board[oldstone] != Blank)) {

    g->moveStatus = status;    /* Set the new board status */
    wh = g->board[oldstone];   /* Save the old color */
    color = otherside[wh];
    g->board[oldstone] = Blank;/* Remove the stone */
    g->brdtohst[oldstone] = sgf->hsttolst[g->brdtohst[oldstone]];
    undrawstone(g,oldstone,drawit);

    nabor = &g->nabor[oldstone];
    for (n = 0; n < nabor->neis; n++) {	/* For neighbors */
      s = nabor->stone[n];
      a1 = g->armymen[s]; 
      if ((crules & GO_DO_UNCAPTURES) && 
	  (g->army[a1].color == Blank) && 
	  ((nabor->direction[n] & g->moveStatus.captures) != 0)) {
	uncapture(g,s,color,drawit,numberit);
	g->army[a1].lib = 1;   /* Set 1 liberty for the removed stone */
      }
      g->army[a1].size = 0;  /* Rebuild the neighbor */
      rolladd(g,a1);
    }
    rolladd(g,g->armymen[oldstone]);
    linkarmies(g);

  } else {
    if (g->who == White) 
	fprintf( stderr, "\rLOCAL: Bad remove by white at %c%d.\n",
	  coltable[g->rowbrd[oldstone]], g->colbrd[oldstone]+1);
    else 
	fprintf( stderr, "\rLOCAL: Bad remove by black at %c%d.\n",
	  coltable[g->rowbrd[oldstone]], g->colbrd[oldstone]+1);
} } 



removedead(g,s,drawit)
game *g; int s; int drawit; {
/* Call this routine to remove an army that has been captured.  The 
   army remains intact, just changes to a blank army.  Neighboring 
   enemy armies have their liberties updated by buildarmies. */
short a1,s1,s2,n;
short wh; 
neighbors *nabor;

  if ((s >= 0) && (s < g->maxStone)) {
    a1 = g->armymen[s];       /* Get the army number */
    if (g->army[a1].color != Blank) {

      wh = g->army[a1].color;     /* Save the army color */

      if (wh == White) 
	g->moveStatus.deadWhite += g->army[a1].size;
      else 
	g->moveStatus.deadBlack += g->army[a1].size;
 
      g->army[a1].color = Blank; /* Change army color to blank */
      g->army[a1].size = 0;   /* Causes army to be rebuilt by buildarmies */
      s1 = g->army[a1].first; /* First man in army */
      
      while (s1 >= 0) {

        g->board[s1] = Blank; /* Change stone color to blank */
        g->brdtohst[s1] = 0;
	undrawstone(g,s1,drawit);
	if( wh == White ) update_prisoners( 1, 0 );
	else update_prisoners( 0, 1 );

/* Clear the size in neighboring enemy armies so they will be rebuilt */
	nabor = &g->nabor[s1];
	for (n = 0; n < nabor->neis; n++) {
	  s2 = nabor->stone[n];
	  a1 = g->armymen[s2]; 
	  if (a1 > 0) {
	    if (g->army[a1].color == otherside[wh]) 
	      g->army[a1].size = 0;
	} }
        s1 = g->armyflnk[s1];  /* Get next army man   */
      }
#if 0	/* Buildarmies is done by Linkarmies in the calling routine, no need here. */
      buildarmies(g);
#endif
    } else {
      fprintf( stderr, "\rLOCAL: Bad capture at %c%d.\n",
        coltable[g->rowbrd[s]], g->colbrd[s]+1);
    }
  } else {
    fprintf( stderr, "\rLOCAL: Bad capture at %c%d.\n",
      coltable[g->rowbrd[s]], g->colbrd[s]+1);
} }



capture(g,s,drawit,numberit)
game *g; int s; int drawit; int numberit; {
/* Call this routine to remove an army that has been captured.  The 
   army remains intact, just changes to a blank army.  Neighboring 
   enemy armies have their liberties updated by buildarmies. */
short a1,s1,s2,n;
short wh; 
neighbors *nabor;

  if ((s >= 0) && (s < g->maxStone)) {
    a1 = g->armymen[s];       /* Get the army number */
    if (g->army[a1].color != Blank) {
      if (g->army[a1].size == 1) {
        g->moveStatus.koSpot = g->army[a1].first;
        g->moveStatus.koColor = g->army[a1].color;
      } else {
        g->moveStatus.koSpot = -1;
      }

      wh = g->army[a1].color;     /* Save the army color */

      if (numberit) {
	if (wh == White) g->moveStatus.deadWhite += g->army[a1].size;
	else g->moveStatus.deadBlack += g->army[a1].size;
      }
      g->army[a1].color = Blank; /* Change army color to blank */
      g->army[a1].size = 0;   /* Causes army to be rebuilt by buildarmies */
      s1 = g->army[a1].first; /* First man in army */
      
      while (s1 >= 0) {

        g->board[s1] = Blank; /* Change stone color to blank */
        g->brdtohst[s1] = 0;
	undrawstone(g,s1,drawit);

/* Clear the size in neighboring enemy armies so they will be rebuilt */
	nabor = &g->nabor[s1];
	for (n = 0; n < nabor->neis; n++) {
	  s2 = nabor->stone[n];
	  a1 = g->armymen[s2]; 
	  if (a1 > 0) {
	    if (g->army[a1].color == otherside[wh]) 
	      g->army[a1].size = 0;
	} }
        s1 = g->armyflnk[s1];  /* Get next army man   */
      }
#if 0	/* Buildarmies is done by Linkarmies in the calling routine, no need here. */
      buildarmies(g);
#endif
    } else {
      fprintf( stderr, "\rLOCAL: Bad capture at %c%d.\n",
        coltable[g->rowbrd[s]], g->colbrd[s]+1);
    }
  } else {
    fprintf( stderr, "\rLOCAL: Bad capture at %c%d.\n",
      coltable[g->rowbrd[s]], g->colbrd[s]+1);
} }



/* Call this routine to uncapture an army that had been captured.  The 
**   army remains intact, just changes to a non-blank army.  Neighboring 
**   enemy armies have their liberties updated by buildarmies. 
*/
uncapture(g,s,wh,drawit,numberit) 
game *g; int s; int wh; int drawit; int numberit; {
short a1,a2,s1,n; 
neighbors *nabor;

  if ((s >= 0) && (s < g->maxStone)) {
    a1 = g->armymen[s];  /* Get the army number */
    if (g->army[a1].color == Blank) {
      if (numberit) {
	if (wh == White) g->moveStatus.deadWhite -= g->army[a1].size;
	else g->moveStatus.deadBlack -= g->army[a1].size;
      }

      g->army[a1].color = wh; /* Change army color to non-blank */
      g->army[a1].size = 0;   /* Causes army to be rebuilt by buildarmies */
      s1 = g->army[a1].first; /* First man in army */
      while (s1 >= 0) {

        g->board[s1] = wh;  /* Change stone color to non-blank */
	drawstone(g,s1,wh,drawit,numberit);

/* Clear the size in neighboring armies so they will be rebuilt */
	nabor = &g->nabor[s1];
	for (n = 0; n < nabor->neis; n++) {   /* for neighbors */
	  a2 = g->armymen[nabor->stone[n]]; 
	  if (g->army[a2].color != wh) g->army[a2].size = 0;
        }
        s1 = g->armyflnk[s1];  /* Get next army man */
      }
#if 0	/* Buildarmies is done by Linkarmies in the calling routine, no need here. */
      buildarmies(g);
#endif
    }
  } else {
      fprintf( stderr, "\rLOCAL: Bad uncapture at %c%d.\n",
        coltable[g->rowbrd[s]], g->colbrd[s]+1);
} }


passplay(g) game *g; {
register short n;
SGFstruct *sgf = &g->sgf;

      set_cursor_color(g->who);
      g->who = otherside[g->who];

  g->playNumber++;
  g->stoneNumber++;
  n = g->stoneNumber;
  g->moveStatus.passCount++;
  g->moveStatus.koSpot = -1;
  g->history[n] = -1;
  sgf->stonenums[n] = g->playNumber;
  sgf->gametype[g->stoneNumber] = sgf->gametype[g->stoneNumber-1];
  g->stathistory[n] = g->moveStatus;
  sgf->typehistory[n] = Pass + g->who;
}



backupend(g,sn,drawit,reposition) 
game *g; int sn; int drawit; int reposition; {
short hist,s1;
SGFstruct *sgf = &g->sgf;

  if (sn < 0) {
    sn = 0;
    g->stoneNumber = 0; 
  } else { 
    g->stoneNumber = sn;

    if ((g->gametype == STEPGAME) && 
	(g->sgf.gametype[g->stoneNumber] == REALGAME) && 
	(g->sgf.gametype[g->stoneNumber+1] != REALGAME)) {
	g->sgf = maingame.sgf;
	for (s1 = g->stoneNumber + 1; s1 < Maxhistory; s1++) 
	  g->history[s1] = maingame.history[s1];
    }
  }
  
  g->playNumber = sgf->stonenums[sn];
  if (g->playNumber < 0)
  	g->playNumber = 0;
  g->moveStatus = g->stathistory[sn];
  g->who = sgf->typehistory[sn] & 1;     /* Black or White only */

/* Draw the last stone again to set the Goban most recent play "dot" */
  if ((sn > 0) && 
      (g->history[sn] >= 0) && 
      !(g->stathistory[sn].captures & SUICIDE_ANY) &&
      (g->sgf.typehistory[sn] < Pass))
    drawstone(g,g->history[sn],g->who,drawit,TRUE);

  if( drawit ) {
      set_cursor_color(g->who);
      g->who = otherside[g->who];
  }
}



backup(g,sn,drawit,crules) 
game *g; 
int sn; 
int drawit;
int crules; {

register int pn,s,stone,typeOfStone;
SGFstruct *sgf = &g->sgf;

  stone = g->history[sn];
  typeOfStone = sgf->typehistory[sn];
  if (typeOfStone >= Blankstone) {
      pn = sgf->hsttolst[sn];
      s = g->history[pn];
      g->board[s] = sgf->typehistory[pn] & 1;
      g->brdtohst[s] = sgf->hsttolst[g->brdtohst[s]];
      drawstone(g,s,g->board[s],drawit,NONUMBERIT); 
      linkastone(g,s);
  } else if ((typeOfStone < Pass) || (typeOfStone >= Handistone)) {
    if (g->stathistory[sn].captures & SUICIDE2) 
      uncapture(g,stone,typeOfStone,drawit,NONUMBERIT);
    if (!(g->stathistory[sn].captures & SUICIDE1)) {
      removeastone(g,stone,g->stathistory[sn],drawit,TRUE,crules);

/* Draw any stone that was underneath the one that was removed */
      pn = sgf->hsttolst[g->stoneNumber];
      if (pn > 0) {
        int typehis = sgf->typehistory[pn];
        if ((typehis < Pass) || ((sgf->typehistory[pn] & 0x7e) == Handistone)) {
	  s = g->history[pn];
	  g->board[s] = typehis & 1;
	  drawstone(g,g->history[pn],g->board[s],drawit,NONUMBERIT);
          linkastone(g,g->history[pn]);
} } } } }

	

int humanforward(g) game *g; {
short 	i = g->stoneNumber + 1,
		s; 

SGFstruct *sgf = &g->sgf;
short typeOfStone = sgf->typehistory[i];
short goodplay = FALSE;

  if ((i < Maxhistory) && (sgf->stonenums[i] > 0)) {
    if (typeOfStone < Pass) {
      g->who = typeOfStone & 1;
      if (g->gametype == STEPGAME) {
        if (addastone(g,g->history[i],DRAWIT,NONUMBERIT,
		      Playstone,((rules==IRULES)?STEP_RULES:GOE_STEP_RULES)) >= 0) 
          goodplay = TRUE;
      } else {
        if (addastone(g,g->history[i],DRAWIT,NONUMBERIT,Playstone,((rules==IRULES)?RULES:GOE_RULES)) >= 0) 
          goodplay = TRUE;
      }
    } else if ((typeOfStone & 0x7e) == Pass) {
      passplay(g);
      return 1;
    } else if ((typeOfStone & 0x7e) == Blankstone) {
      if (g->gametype == STEPGAME) {
        liftastone(g,g->history[i],STEPGAME);
	goodplay = TRUE;
      }
    }

    if (goodplay) {
      set_cursor_color(g->who);
      g->who = otherside[g->who];
      return 1;
    }
  } 
  return 0;
}



setcursorcolor(g) game *g; {	/* Set cursor color from last play */
SGFstruct *sgf = &g->sgf;
  g->who = sgf->typehistory[g->stoneNumber] & 1;     /* Black or White only */
  set_cursor_color(g->who);
}



nomorehistory(g) game *g; {
short i;
SGFstruct *sgf = &g->sgf;
  for (i = g->stoneNumber + 1; i < Maxhistory; i++) {
    sgf->stonenums[i] = 0; 
    sgf->gametype[i] = -1;
    g->history[i] = 0;
    sgf->typehistory[i] = Playstone;
  }
  setcursorcolor(g);
}
